package data;

import history.History;
import ringclient.ClientRingDynamics;

public class SimulationGuide {
//	public double[][] guides;	
	private double[][][][] values;
//	private static final double[][][] guides = new double[][][] { {{ 0.0, 1.0, 0.0 },
//		{ 0.8, 0.0, 0.2 },
//		{ 0.8, 0.0, 0.2 },
//		{ 0.0, 0.0, 1.0 },
//		{ 0.0, 0.0, 1.0 },
//		{ 0.8, 0.0, 0.2 }},
//			{{ 0.5, 0.2, 0.3 },
//			{ 0.5, 0.2, 0.3 },
//			{ 0.5, 0.2, 0.3 },
//			{ 0.0, 0.2, 0.8 },
//			{ 0.0, 0.2, 0.8 },
//			{ 0.5, 0.2, 0.3 }},
//				{{ 0.3, 0.3, 0.4 },
//				{ 0.3, 0.3, 0.4 },
//				{ 0.3, 0.3, 0.4 },
//				{ 0.0, 0,5, 0.5 },
//				{ 0.0, 0.5, 0.5 },
//				{ 0.3, 0.3, 0.4 }},
//					{{ 0.1, 0.7, 0.2 },
//					{ 0.1, 0.7, 0.2 },
//					{ 0.1, 0.7, 0.2 },
//					{ 0.0, 0,75, 0.25 },
//					{ 0.0, 0.75, 0.25 },
//					{ 0.1, 0.7, 0.2 }},
//						{{ 0.0, 1.0, 0.0 },
//						{ 0.0, 0.9, 0.1 },
//						{ 0.0, 0.9, 0.1 },
//						{ 0.0, 1.0, 0.0 },
//						{ 0.0, 1.0, 0.0 },
//						{ 0.0, 0.9, 0.1 }}
//		};
	
	@SuppressWarnings("unused")
	static private double[][][][] estimates;
	
	private static final double[][][] own_guides = new double[][][] { {{ 0.0, 1.0, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 }},
			{{ 0.0, 1.0, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 }},
				{{ 0.0, 1.0, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 }},
					{{ 0.0, 1.0, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 }},
						{{ 0.0, 1.0, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 }},
		};
	
	private static final double[][][] guides = new double[][][] { {{ 0.0, 1.0, 0.0 },
		{ 0.15, 0.15, 0.7 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 },
		{ 0.5, 0.5, 0.0 }},
			{{ 0.0, 1.0, 0.0 },
			{ 0.2, 0.8, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 },
			{ 0.5, 0.5, 0.0 }},
				{{ 0.0, 1.0, 0.0 },
				{ 0.65, 0.35, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 },
				{ 0.5, 0.5, 0.0 }},
					{{ 0.0, 1.0, 0.0 },
					{ 0.6, 0.4, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 },
					{ 0.5, 0.5, 0.0 }},
						{{ 0.0, 1.0, 0.0 },
						{ 0.8, 0.2, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 },
						{ 0.5, 0.5, 0.0 }},
		};
	
	static public synchronized void setEstimates() {
		SimulationGuide.estimates = History.getHistory().getCurrent().getPlayerEstimate();
	}

	public SimulationGuide(ClientRingDynamics crd) {
		values = new double[CONSTANT.PLAYER_COUNT][6][Bucket.BUCKET_COUNT][3];
		fillGuides(crd);
	}

	private synchronized void fillGuides(ClientRingDynamics crd) {
		// RAISE, CALL, FOLD
//		if (!History.getHistory().isActive()) {
			for (int i = 0; i < CONSTANT.PLAYER_COUNT; i++) {
				if (crd.seatTaken == i) {
					values[i] = own_guides;
				} else {
					values[i] = guides;
				}

			}
//		} else {
//			for (int i = 0; i < CONSTANT.PLAYER_COUNT; i++)
//				if (crd.seatTaken == i)
//					values[i] = own_guides;
//				else 
//					values[i] = SimulationGuide.estimates[crd.seatToPlayer(i)];
//		}
	}
	
	public double getValue(int seat, int round, int bucket, int decision) {
		if (bucket == -1)
			bucket = 0;
		return values[seat][bucket][round + 1][decision];
	}
}
