package simulation.datastructure;

import simulation.interfaces.IArc;
import simulation.interfaces.INode;

public class LeafNode extends AbstractNode implements INode {


	private double value;

	public LeafNode(IArc parentArc, long id) {
		super(parentArc, id);
	}

	public LeafNode(long id) {
		super(id);
	}

	public double getValue() {
		return value;
	}
	
	public void setValue(double value) {
		this.value = value;
	}
}
